// -*- MaTX -*-

// sim00027.mm: tmd00027.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/10/02>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00027.mm,v 1.2 1999/10/06 13:41:03 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00027_USER_H "sim00027.h"
#define TMD00027_USER_MM "sim00027.mm"

// TMD00027_USER_H  #include 롣
#include "tmd00027.h"

// ƥȥΤ
Real DURD, DIRD;

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
  Integer replot;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */
  Index ind;
  Integer TestCase;

  TestCase = 1;
//  read TestCase;

  init_tmd00027(1); // Υߥ졼
//  init_tmd00027(0); // Υߥ졼(not given)
  switch (TestCase)
    {
    default:
    case 1:
      tmd00027(delta_eps) = [0, 0, 0, 0, 0]';
      {DURD, DIRD} = {0.5, 0.5};  break;
    case 2:
      tmd00027(delta_eps) = [-1, -1, -1, 1, 1]';
      {DURD, DIRD} = {-0.5, -0.5};  break;
    case 3:
      tmd00027(delta_eps) = [1, 1, 1, 1, -1]';
      {DURD, DIRD} = {-0.5, -0.5};  break;
    case 4:
      tmd00027(delta_eps) = [1, 1, 1, 1, 1]';
      {DURD, DIRD} = {0.5, -0.5};  break;
    case 5:
      tmd00027(delta_eps) = [-1, 1, 0, 0, 0]';
      {DURD, DIRD} = {-0.5, -0.5};  break;
    }
//  tmd00027(delay) = Z(7,5); // for no delay
  init_tmd00027(1, 1);

//  {TC, XC, UC} = Ode45HybridAuto(0.0, 60.0, /* min */
  {TC, XC, UC} = Ode45Hybrid(0.0, 60.0, /* min */
			     1.0, /* min */
#ifndef TMD00027_USER_DIFF
			     // initial values not given
			     Z(TMD00027_DIM_STATE,1),
#else /* TMD00027_USER_DIFF */
			     [[Z(TMD00027_DIM_STATE,1)]
			      [[0.0, 0.0]']], // ưŪν
#endif /* ! TMD00027_USER_DIFF */
			     diff_tmd00027, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"UTD->YTEP", "UTD->YSEP", "UTD->XTT ", "UTD->XURT", "UTD->XSDT",
	   "UTD->XIRT", "UTD->XBRT",
	   "USD->YTEP", "USD->YSEP", "USD->XTT ", "USD->XURT", "USD->XSDT",
	   "USD->XIRT", "USD->XBRT",
	   "UBRD->YTEP", "UBRD->YSEP", "UBRD->XTT", "UBRD->YURT",
	   "UBRD->XSDT", "UBRD->XIRT", "UBRD->XBRT",
	   "DIRD->YTEP", "DIRD->YSEP", "DIRD->XTT", "DIRD->YURT",
	   "DIRD->XSDT", "DIRD->XIRT", "DIRD->XBRT",
	   "DURD->YTEP", "DURD->YSEP", "DURD->XTT", "DURD->YURT",
	   "DURD->XSDT", "DURD->XIRT", "DURD->XBRT",
	   "UTD(real)", "USD(real)", "UBRD(real)", // XC
#ifdef TMD00027_USER_DIFF
	   "(z1)", "(z2)",  // ưŪξ
#endif /* TMD00027_USER_DIFF */
	   "UTD(nom)", "USD(nom)", "UBRD(nom)", "DIRD", "DURD",
	   "YTEP", "YSEP", "XTT", "XURT", "XSDT", "XIRT", "XBRT" // UC
	 };
  replot = 0;

#ifndef MULTIPLOT
  for (i = 1; i <= length(names); ++i)
    {
      if (names(i, String) == "-") { continue; }
      mgplot_grid(i, 1);
      if (! replot)
	{
	  mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
	}
      else
	{
	  mgreplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
	  replot = 1;
	}	      
    }
#else /* MULTIPLOT */
//  hmultiplot(1, TC, [[XC][UC]], names, replot);
  ind = Index([1 8 15 22 29 44]);
#ifdef TMD00027_USER_DIFF
  ind(6) = ind(6) + 2;
#endif /* TMD00027_USER_DIFF */
  hmultiplot(1, TC, [[XC][UC]](ind,:), names(ind), 0);
  for (i = 1; i <= 6; ++i) {
    ind = ind .+ 1;
    hmultiplot(1, TC, [[XC][UC]](ind,:), names(ind), 1);
  }
#ifndef TMD00027_USER_DIFF
  ind = Index([39 40 41 42]);
  hmultiplot(3, TC, [[XC][UC]](ind,:), names(ind), 0);
  ind = Index([36 37 38 43]);
  hmultiplot(3, TC, [[XC][UC]](ind,:), names(ind), 1);
#else /* TMD00027_USER_DIFF */
  ind = Index([41 42 43 44]);
  hmultiplot(3, TC, [[XC][UC]](ind,:), names(ind), 0);
  ind = Index([36 37 38 45]);
  hmultiplot(3, TC, [[XC][UC]](ind,:), names(ind), 1);
  ind = Index([39 40]);
  hmultiplot(4, TC, [[XC][UC]](ind,:), names(ind), 0);
#endif /* ! TMD00027_USER_DIFF */

#endif /* ! MULTIPLOT */
#endif /* ! NOPLOT */
  pause;
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix uy;
  static Integer running;
  static Matrix u;
  Matrix x, y;
  Real I;

  static Real tt;
  if (t >= tt)
    {
      print t;
      tt = tt + 1.0;
    }

  if (running == 0) // ߥ졼󳫻ϻ
    {
      uy = Z(TMD00027_DIM_ALL_IOS,1);
      u = chop_input_tmd00027(uy);
      running = 1;
    }

  x = chop_state_tmd00027(xx);
  y = output_tmd00027(t, x, u);

//  u = [0.25, 0.25, 0.25,
//  u = [0.0, 0.0, 0.0,
  u = [0.1, -0.1, 0.1, // UTD, USD, UBRD (ø)
       DIRD, DURD]'; // DIRD, DURD

  uy = [[u]
	[y]];
  return uy;
}


#ifdef TMD00027_USER_DIFF
// ߡưŪ
Func Matrix
TMD00027_USER_DIFF(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix x, z, u, y; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00027(xx);
  z = chop_other_state_tmd00027(xx);
  u = chop_input_tmd00027(uu);
  y = output_tmd00027(t, x, u);
  // etc.

  return [1.0, -1.0]'; // ߡΤøʥʥߥ ;-)
}
#endif /* TMD00027_USER_DIFF */


#ifdef TMD00027_USER_FUNC_DIRD_DURD
// ǥ DIRD(u(4)), DURD(u(5)) Ʊ/Ϣ³˳Ϳ
// (u(4), u(5)  override 롣)
Func Matrix
TMD00027_USER_FUNC_DIRD_DURD(t, xx, uu)
     Real t; /* min */
     Matrix xx, uu;
{
  Real DIRD, DURD;

  // øʶ
  DIRD = 0.5*sgn(sin(2.0*PI*(t - 1.5)/3.5));
  DURD = 0.5*sgn(sin(2.0*PI*(t - 3.25)/7.5));
  return [DIRD, DURD]';
}
#endif /* TMD00027_USER_FUNC_DIRD_DURD */
