/* -*- MaTX -*-
 *
 * tmd00027.mm: TMD No. tmd00027 ץ(żαץ)
 *
 *  Originally written by KIYOTA Hiromitsu <1999/10/02>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00027.mm,v 1.2 1999/10/06 13:44:05 kiyota Exp $
 */

#ifndef _TMD00027_MM
#define _TMD00027_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00027.h"

// some definitions for local alist
#ifndef TMD00027_DISABLE_HALIST
#define _TMD_LALIST {"_tmd00027"}
#define _TMD_LIN_FLAG "linear_flag"
#define _TMD_DIFF_RUNNING "diff_running"
#define _TMD_DIFF_XX0 "diff:_xx0"
#define _TMD_DIFF_UU0 "diff:_uu0"
#endif /* ! TMD00027_DISABLE_HALIST */

// just for simplicity... B)
#define tmd27(var) tmd00027(var)

Func void
init_tmd00027(linear_flag, params_flag, ...)
     Integer linear_flag, params_flag;
{
#ifndef TMD00027_DISABLE_HALIST
  List halist(...);
#else /* TMD00027_DISABLE_HALIST */
  Integer _tmd00027_diff_running(...);
#endif /* ! TMD00027_DISABLE_HALIST */
  Polynomial s;
  Integer dss, i, j, k, l;
  Matrix DeG, Atmp, Btmp, Ctmp, Dtmp, gain;

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      linear_flag = 1; // ǥե: ǥ
    case 1:
      params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00027(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

#ifndef TMD00027_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_LIN_FLAG, linear_flag}}); // ()Υե饰
  halist(_TMD_LALIST, {{_TMD_DIFF_RUNNING, 0}});
#else /* TMD00027_DISABLE_HALIST */
  tmd00027_flag = linear_flag;
  _tmd00027_diff_running(0);
#endif /* ! TMD00027_DISABLE_HALIST */

  if (params_flag == 0)
    {
      // 5  7 : (̵)
      //  UTD:  ĺȴФ (Top Draw)
      //      USD:  ȴФ (Side Draw)
      //      UBRD: Ǯ (Bottoms Reflux Duty)
      //      DIRD: ֳήǮ (Intermediate Reflux Duty)
      //      DURD: ήǮ (Upper Reflux Duty)
      //  YTEP: ĺ (Top End Point)
      //      YSEP: ȴФ (Side End Point)
      //      XTT:  ĺ (Top Temp)
      //      XURT: ή (Upper Reflux Temp)
      //      XSDT: ȴФ (Side Draw Temp)
      //      XIRT: ֳή (Intermediate Reflux Duty)
      //      XBRT: ή (Bottom Reflux Temp)

      s = Polynomial("s");
      // (Ϣ³)ãؿǥ(Ȥ֤)
      tmd27(G) = 
	[[1/(50*s+1), 1/(60*s+1), 1/(50*s+1), 1/(45*s+1), 1/(40*s+1)]
	 [1/(50*s+1), 1/(60*s+1), 1/(40*s+1), 1/(25*s+1), 1/(20*s+1)]
	 [1/( 9*s+1), 1/(30*s+1), 1/(40*s+1), 1/(11*s+1), 1/( 6*s+1)]
	 [1/(12*s+1), 1/(27*s+1), 1/(20*s+1), 1/( 5*s+1), 1/(19*s+1)]
	 [1/( 8*s+1), 1/(19*s+1), 1/(10*s+1), 1/( 2*s+1), 1/(22*s+1)]
	 [1/(13*s+1), 1/(33*s+1), 1/( 9*s+1), 1/(19*s+1), 1/(24*s+1)]
	 [1/(33*s+1), 1/(44*s+1), 1/(19*s+1), 1/(27*s+1), 1/(32*s+1)]];
      // ([min])
      tmd27(delay) =
	[[27, 28, 27, 27, 27]
	 [18, 14, 15, 15, 15]
	 [ 2, 20,  2,  0,  0]
	 [11, 12,  2,  0,  0]
	 [ 5,  7,  2,  0,  0]
	 [ 8,  4,  1,  0,  0]
	 [20, 22,  0,  0,  0]];
      // ãؿǥΥΥߥʥ륲
      tmd27(gnom) =
	[[4.05, 1.77, 5.88, 1.20, 1.44]
	 [5.39, 5.72, 6.90, 1.52, 1.83]
	 [3.66, 1.65, 5.53, 1.16, 1.27]
	 [5.92, 2.54, 8.10, 1.73, 1.79]
	 [4.13, 2.38, 6.23, 1.31, 1.26]
	 [4.06, 4.18, 6.53, 1.19, 1.17]
	 [4.38, 4.42, 7.20, 1.14, 1.26]];
      // ãؿǥΥԳη
      tmd27(coef) =
	[[2.11, 0.39, 0.59, 0.12, 0.16]
	 [3.29, 0.57, 0.89, 0.13, 0.13]
	 [2.29, 0.35, 0.67, 0.08, 0.08]
	 [2.34, 0.24, 0.32, 0.02, 0.04]
	 [1.71, 0.93, 0.30, 0.03, 0.02]
	 [2.39, 0.35, 0.72, 0.08, 0.01]
	 [3.11, 0.73, 1.33, 0.18, 0.18]];
      // ãؿǥΥԳΥѥ᡼ [-1,1]
      tmd27(delta_eps) = [0.0, 0.0, 0.0, 0.0, 0.0]';

      // ̤ hard limit
      tmd27(u_max) = [0.5, 0.5, 0.5]'; // UTD, USD, UBRD
      tmd27(u_min) = [-0.5, -0.5, -0.5]'; // UTD, USD, UBRD
      // ѿѲ®٤
      tmd27(du_lim) = diag([0.05], [0.05], [0.05]); // UTD, USD, UBRD
    }
  
  // ʲֶɽƤ뤬ΤȤƺǾ¸ˤʤäƤȤ
  // ¤ʤΤա(ϤΤ֤ȽϤΥԳȤη͹礤)
  dss = 0;  // ֶɽμ
  DeG = De(Array(tmd27(G)));
  for (i = 1; i <= Rows(DeG); ++i)
    {
      for (j = 1; j <= Cols(DeG); ++j)
	{
	  dss = dss + degree(DeG(i,j));
	}
    }
  tmd27(A) = Z(dss);
  tmd27(B) = Z(dss,Rows(tmd27(G))*Cols(tmd27(G)));
  tmd27(C) = Z(Rows(tmd27(G)),dss);
  tmd27(D) = Z(Rows(tmd27(G)),Rows(tmd27(G))*Cols(tmd27(G)));
  gain = tmd27(gnom) + tmd27(coef)*vec2diag(tmd27(delta_eps));
  k = l = 1;
  for (j = 1; j <= Cols(tmd27(G)); ++j)
    {
      for (i = 1; i <= Rows(tmd27(G)); ++i)
	{
	  {Atmp,Btmp,Ctmp,Dtmp} = tfm2ss([gain(i,j)*tmd27(G)(i,j)], 1);
	  tmd27(A)(k:,k:) = Atmp;
	  tmd27(B)(k:,l:) = Btmp;
	  tmd27(C)(i:,k:) = Ctmp;
	  tmd27(D)(i:,l:) = Dtmp;
	  k = k + Rows(Atmp);  ++l;
	}
    }
}


Func Matrix
diff_tmd00027(t, xx, uu)
     Real t; /* min */	// 
     Matrix xx, uu;
{
  Matrix dxx;
#ifndef TMD00027_DISABLE_HALIST
  List halist(...);
#else /* TMD00027_DISABLE_HALIST */
  Integer _tmd00027_diff_running(...);
  List _tmd00027_diff_init_args(...);
#endif /* ! TMD00027_DISABLE_HALIST */
  Matrix dx, x, u;
  Matrix _tmd00027_delayed_input();
#ifdef TMD00027_USER_DIFF
  Matrix TMD00027_USER_DIFF();
#endif /* TMD00027_USER_DIFF */
  Matrix ua, ub;

#ifndef TMD00027_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_DIFF_RUNNING}) == {0}) // when the first time
    {
      halist(_TMD_LALIST, {{_TMD_DIFF_RUNNING, 1},
			   {_TMD_DIFF_XX0, xx}, // ֤¸
			   {_TMD_DIFF_UU0, uu}}); // Ϥ¸
    }
#else /* TMD00027_DISABLE_HALIST */
  if (_tmd00027_diff_running() == 0) // /Ϥ¸
    {
      _tmd00027_diff_running(1);
      _tmd00027_diff_init_args(xx, uu);
    }
#endif /* ! TMD00027_DISABLE_HALIST */

  x = chop_state_tmd00027(xx);
  u = chop_input_tmd00027(uu);

#if 0
#ifndef TMD00027_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_LIN_FLAG}) == {0}) // ǥ
#else /* TMD00027_DISABLE_HALIST */
  if (tmd00027_flag == 0) // ǥ
#endif /* ! TMD00027_DISABLE_HALIST */
    {
      // not given.
    }
  else // ǥ
    {
#endif /* 0 */
      ua = _tmd00027_delayed_input(t, xx, uu);
      ub = -sgn(x(Rows(tmd27(A))+1:Rows(tmd27(A))+3) - u(1:3));
      dx = diag(tmd27(A),Z(3))*x + diag(tmd27(B),tmd27(du_lim))*[[ua][ub]];
#if 0
    }
#endif /* 0 */

  dxx = [[dx]
#ifdef TMD00027_USER_DIFF
	 [TMD00027_USER_DIFF(t, xx, uu)]
#endif /* TMD00027_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00027(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
  Matrix y;
#ifndef TMD00027_DISABLE_HALIST
  List halist(...);
#else /* TMD00027_DISABLE_HALIST */
  Integer _tmd00027_diff_running(...);
  List _tmd00027_diff_init_args(...);
#endif /* ! TMD00027_DISABLE_HALIST */
  Matrix _tmd00027_delayed_input();
  Matrix x, u, xa, ua;

#ifndef TMD00027_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_DIFF_RUNNING}) == {0}) // when the first time
    {
      halist(_TMD_LALIST, {{_TMD_DIFF_RUNNING, 1},
			   {_TMD_DIFF_XX0, xx}, // ֤¸
			   {_TMD_DIFF_UU0, uu}}); // Ϥ¸
    }
#else /* TMD00027_DISABLE_HALIST */
  if (_tmd00027_diff_running() == 0) // /Ϥ¸
    {
      _tmd00027_diff_running(1);
      _tmd00027_diff_init_args(xx, uu);
    }
#endif /* ! TMD00027_DISABLE_HALIST */

  x = chop_state_tmd00027(xx);
  u = chop_input_tmd00027(uu);

  xa = x(1:Cols(tmd27(C)));
  ua = _tmd00027_delayed_input(t, xx, uu);
  y = tmd27(C)*xa + tmd27(D)*ua;

  return y;
}


Func Matrix
_tmd00027_delayed_input(t, xx, uu)
     Real t;
     Matrix xx, uu;
{
#ifndef TMD00027_DISABLE_HALIST
  List halist(...);
#else /* TMD00027_DISABLE_HALIST */
  List _tmd00027_diff_init_args(...);
#endif /* ! TMD00027_DISABLE_HALIST */
#ifdef TMD00027_USER_FUNC_DIRD_DURD
  Matrix TMD00027_USER_FUNC_DIRD_DURD();
#endif /* TMD00027_USER_FUNC_DIRD_DURD */
  Integer i, j, k;
  Matrix u, x_d, u_d;
  Real t_d;

  k = 1;
  u = Z(Cols(tmd27(B)), 1);
  for (j = 1; j <= Cols(tmd27(delay)); ++j)
    {
      for (i = 1; i <= Rows(tmd27(delay)); ++i)
	{
	  t_d = t;
	  if (t >= tmd27(delay)(i,j))
	    {
	      if (tmd27(delay)(i,j) > 0.0)
		{
		  t_d = t - tmd27(delay)(i,j);
		  {x_d, u_d} = OdeXY(t_d);
		}
	      else
		{
		  {x_d, u_d} = {xx, uu};
		}
	    }
	  else
	    {
#ifndef TMD00027_DISABLE_HALIST
	      {x_d, u_d} = halist(_TMD_LALIST, {_TMD_DIFF_XX0, _TMD_DIFF_UU0});
#else /* TMD00027_DISABLE_HALIST */
	      {x_d, u_d} = _tmd00027_diff_init_args();
#endif /* ! TMD00027_DISABLE_HALIST */
	    }
#ifdef TMD00027_USER_FUNC_DIRD_DURD
	  u_d(4:5) = TMD00027_USER_FUNC_DIRD_DURD(t_d, x_d, u_d);
#endif /* TMD00027_USER_FUNC_DIRD_DURD */
	  {x_d, u_d} = {chop_state_tmd00027(x_d), chop_input_tmd00027(u_d)};
	  if (j <= 3) // for UTD, USD and UBRD
	    {
	      u(k) = x_d(Rows(tmd27(A)) + j);
	      if (u(k) > tmd27(u_max)(j))
		{
		  u(k) = tmd27(u_max)(j);
		}
	      else if (u(k) < tmd27(u_min)(j))
		{
		  u(k) = tmd27(u_min)(j);
		}
	    }
	  else // for DIRD and DURD
	    {
	      u(k) = u_d(j);
	    }
	  ++k;
	}
    }
  return u;
}


#ifdef TMD00027_DISABLE_HALIST
Func Integer
_tmd00027_diff_running(flag, ...)
     Integer flag;
{
  static Integer running; // defaults to 0

  switch (nargs)
    {
    case 1:
      running = flag;
    case 0:
      return running;
      break;
    default:
      error("_tmd00027_diff_running(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }
}

Func List
_tmd00027_diff_init_args(x, u, ...)
     Matrix x, u;
{
  static Matrix xx0, uu0; // the default not cared

  switch (nargs)
    {
    case 2:
      {xx0, uu0} = {x, u};
    case 0:
      return {xx0, uu0};
      break;
    default:
      error("_tmd00027_diff_init_args(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }
}
#endif TMD00027_DISABLE_HALIST


#undef tmd27
#ifndef TMD00027_DISABLE_HALIST
#undef _TMD_LALIST
#undef _TMD_LIN_FLAG
#undef _TMD_DIFF_RUNNING
#undef _TMD_DIFF_XX0
#undef _TMD_DIFF_UU0
#endif /* ! TMD00027_DISABLE_HALIST */

#endif /* !_TMD00027_MM */
